/*C*****************************************************************************
* FILE_NAME         : api_task.c                                             
*----------------------------------------------------------------------------
* FILE_CREATED_BY   : BERTHY JS                                             
* FILE_CREATION_DATE: 16/05/00                                              
*----------------------------------------------------------------------------
* FILE_PURPOSE:    
* user api API_ERASE_BLOCK1 2 & 3
* user api API_READ_DATA
* user api ID_API_LAUNCH_PRG_FLASH
* user api API_WR_BSB
* user api API_WR_EB
* user api API_WR_SBV
* user api API_WR_SSB
* user api API_RD_BSB
* user api API_RD_SBV
* user api API_RD_EB
* user api API_RD_SSB
* user api API_PRG_HW
* user api API_RD_HW
* user api API_RD_MANUFACTURER
* user api API_RD_ID1
* user api API_RD_ID2
* user api API_RD_ID3
* user api API_RD_BOOTLOADER_VERSION
* user api API_RD_DEVICE_BOOT_ID1
* user api API_RD_DEVICE_BOOT_ID2

******************************************************************************/

/*_____ I N C L U D E - F I L E S ____________________________________________*/

#include "compiler.h"
#include "config.h"
#include "bootloader.h"


/*_____ G L O B A L S ________________________________________________________*/

Uchar  api_command 	_at_ 0x1C;
Uchar  api_value 		_at_ 0x1D;
Uchar  api_dpl 			_at_ 0x1F;
Uchar  api_dph 			_at_ 0x1E;


/*_____ P R I V A T E - F U N C T I O N S - D E C L A R A T I O N ____________*/




/*_____ L O C A L S __________________________________________________________*/


/*_____ P U B L I C - F U N C T I O N S ______________________________________*/

/*_____ P R I V A T E - F U N C T I O N S ____________________________________*/

/*F****************************************************************************
* FUNCTION_NAME: api_task_init                                                   
*----------------------------------------------------------------------------
* FUNCTION_AUTHOR: BERTHY J.S.                                              
* FUNCTION_DATE  :                                          
*----------------------------------------------------------------------------
* FUNCTION_PURPOSE:   
* FUNCTION_INPUTS : void                                                          
* FUNCTION_OUTPUTS: void                                                       
******************************************************************************/
void api_task_init (void)
{
  api_command = WAIT_COMMAND;
}


/*F****************************************************************************
* FUNCTION_NAME:  api_task                                                 
*----------------------------------------------------------------------------
* FUNCTION_AUTHOR: BERTHY J.S.                                              
* FUNCTION_DATE  :                                          
*----------------------------------------------------------------------------
* FUNCTION_PURPOSE:   
* FUNCTION_INPUTS : void                                                          
* FUNCTION_OUTPUTS: void                                                       
******************************************************************************/
void api_task(void)
{

// Valeur  charger dans A = api_value;
// valeur  charger dans DPTR = api_dptr;
// valeur de retour api_value; 
// DPTR1 est utilis pour la programation par page

  switch (api_command)
  {
    case WAIT_COMMAND:
  	{
      break;
	  }

// user api API_ERASE_BLOCK1 2 & 3
    case ID_API_ERASE_BLOCK:	
	  {
      DPH = api_dph;
      DPL = 0;
      if (api_dph < 0x40)
	    {
        API_ERASE_BLOC_8K();
      }
	    else
	    {
        API_ERASE_BLOC_16K();
	    }
	    api_command = WAIT_COMMAND;
	    break;
	  }

		case ID_API_LAUNCH_PRG_FLASH:
		{
 			API_LAUNCH_PRG_FLASH();
			api_value   = COMMAND_OK;
      api_command = WAIT_COMMAND;      
      break;
	  }

// user api API_READ_DATA
    case ID_API_READ_DATA: 		
	  {
      DPL = api_dpl;
      DPH = api_dph;
			API_RD_FLASH();
			api_value = ACC;
	    break;
	  }

// user api API_WR_BSB
// user api API_WR_EB
// user api API_WR_SBV
// user api API_WR_SSB
    case ID_API_PROGRAM_XAF:
	  {
      DPH = 0x00;
      DPL = api_dpl;
      ACC = api_value;
      API_WR_FLASH_CL();	  
			API_LAUNCH_PRG_XAF();
			api_value   = COMMAND_OK;
      api_command = WAIT_COMMAND;      
      break;
	  }

// user api API_RD_BSB
// user api API_RD_SBV
// user api API_RD_EB
// user api API_RD_SSB
// user api API_RD_MANUFACTURER
// user api API_RD_ID1
// user api API_RD_ID2
// user api API_RD_ID3
    case ID_API_READ_XAF: 	
	  {
      DPH = 0x00;
      DPL = api_dpl; 
	    API_RD_XAF();
	    api_value   = ACC;
	    api_command = WAIT_COMMAND;
			break;
	  }

// user api API_RD_BOOTLOADER_VERSION
// user api API_RD_DEVICE_BOOT_ID1
// user api API_RD_DEVICE_BOOT_ID2
    case ID_API_READ_SPECIAL: 	
	  {
			switch(api_dpl)
			{
			case 0x00:
	     	api_value = BOOTLOADER_VERSION;
				break;
			case 0x01:
	     	api_value = DEVICE_BOOT_ID1;
				break;
			case 0x02:
	     	api_value = DEVICE_BOOT_ID2;
				break;
			}
 	    api_command = WAIT_COMMAND;
			break;
	  }


// user api API_FULL_CHIP_ERASE
    case ID_API_FULL_CHIP_ERASE: 
	  {
      DPH = 0;
      DPL = 0;
      API_FULL_CHIP_ERASE();	  
	    api_command = WAIT_COMMAND;
      break;
	  }

// user api API_PRG_HW
    case ID_API_PROGRAM_FUSE_BIT: 
	  {
      DPL = 00;
	    DPH = 00;
      ACC = api_value;
			API_LAUNCH_PRG_FUSE();
			api_value   = COMMAND_OK;
      api_command = WAIT_COMMAND;      
	    break;
	  }

// user api API_RD_HW
    case ID_API_READ_HW:
	  {
      DPL = 00;
	    DPH = 00;
      API_RD_HW();
	    api_value   = ACC;
	    api_command = WAIT_COMMAND;
	    break;
	  }
// user api API_RD_EEPROM
    case ID_API_READ_EEPROM:
	  {
      DPL = api_dpl;
	    DPH = api_dph;
      API_RD_EEPROM();
	    api_value 	= ACC;
	    api_command = WAIT_COMMAND;
	    break;
	  }
		default:
		{
	    api_command = WAIT_COMMAND;
		}
  }
}




